# NetObserv SNMP

NetObserv SNMP is more than a simple SNMP poller. It has been designed to meet the requirements of the most demanding production environments, with particular attention on the following attributes:

#### Turnkey

NetObserv SNMP puts an end to countless hours of building polling configurations, and the error-prone copy-pasting necessary to poll new devices, which is required of other solutions. SNMP MIB attributes must be defined only once and can be flexibly referenced by the devices to which they are applicable.

NetObserv SNMP includes a growing collection of out-of-the-box MIB Object definitions, as well as Object Groups and Device Groups, which make it quick and easy to get started polling your environment. This enables the collector to understand how to poll a Juniper EX-Series differently than a Cisco Catalyst. Adding a device is as simple as providing an IP address, credentials and one or more Device Groups, e.g. `juniper_ex`.

![snmp\_definitions](https://user-images.githubusercontent.com/10326954/203154862-64b96560-a053-4fad-bea4-22cbe04863c0.png)

#### Extensible

NetObserv SNMP includes pre-built support for some of the most popular network equipment, which will continue to grow in the future. However there will always be new, rare or custom devices which are not yet part of our pre-built options. In this scenario, it is easy for users to add configurations or even modify existing definitions.

#### Efficient

The key to using SNMP with a minimal impact on network bandwidth and device resources is efficient polling. NetObserv SNMP achieves this by first performing a low-touch discovery of Objects applicable to the target device. The resulting *SNMP object inventory* is leveraged by the scheduler to poll devices in the most efficient manner possible. It is not uncommon for our pollers to collect 50 or more OIDs in a single poll. This greatly reduces the number of packets sent out over the network, as well as the load on the limited resources found in many devices.

#### Adaptive

It isn’t uncommon for devices to be reconfigured or restarted for maintenance or other operational requirements. NetObserv SNMP can respond dynamically to detected changes, modifying the polling schedule to remove objects and attributes which are no longer available, or automatically trigger a rediscovery when warranted by a device’s new state.

#### Scalable

ElastiFlow has proven itself as perhaps the most scalable Flow Collector available, especially when considering its depth of processing and features. NetObserv SNMP provides this same level of scalability by:

1. Leveraging a large (and configurable) pool of concurrent poller workers.
2. Taking advantage of the same processing techniques and outputs as NetObserv Flow.

### Enabling SNMP Collection

To enable NetObserv SNMP, refer to the configuration reference [HERE](/snmpcoll/configuration/input_snmp.md). Devices can be added as explained [HERE](/snmpcoll/configuration/def_devices.md).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.elastiflow.com/snmpcoll.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
